// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"github.com/hay-kot/homebox/backend/internal/data/ent/itemfield"
	"github.com/hay-kot/homebox/backend/internal/data/ent/predicate"
)

// ItemFieldDelete is the builder for deleting a ItemField entity.
type ItemFieldDelete struct {
	config
	hooks    []Hook
	mutation *ItemFieldMutation
}

// Where appends a list predicates to the ItemFieldDelete builder.
func (ifd *ItemFieldDelete) Where(ps ...predicate.ItemField) *ItemFieldDelete {
	ifd.mutation.Where(ps...)
	return ifd
}

// Exec executes the deletion query and returns how many vertices were deleted.
func (ifd *ItemFieldDelete) Exec(ctx context.Context) (int, error) {
	return withHooks[int, ItemFieldMutation](ctx, ifd.sqlExec, ifd.mutation, ifd.hooks)
}

// ExecX is like Exec, but panics if an error occurs.
func (ifd *ItemFieldDelete) ExecX(ctx context.Context) int {
	n, err := ifd.Exec(ctx)
	if err != nil {
		panic(err)
	}
	return n
}

func (ifd *ItemFieldDelete) sqlExec(ctx context.Context) (int, error) {
	_spec := sqlgraph.NewDeleteSpec(itemfield.Table, sqlgraph.NewFieldSpec(itemfield.FieldID, field.TypeUUID))
	if ps := ifd.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	affected, err := sqlgraph.DeleteNodes(ctx, ifd.driver, _spec)
	if err != nil && sqlgraph.IsConstraintError(err) {
		err = &ConstraintError{msg: err.Error(), wrap: err}
	}
	ifd.mutation.done = true
	return affected, err
}

// ItemFieldDeleteOne is the builder for deleting a single ItemField entity.
type ItemFieldDeleteOne struct {
	ifd *ItemFieldDelete
}

// Where appends a list predicates to the ItemFieldDelete builder.
func (ifdo *ItemFieldDeleteOne) Where(ps ...predicate.ItemField) *ItemFieldDeleteOne {
	ifdo.ifd.mutation.Where(ps...)
	return ifdo
}

// Exec executes the deletion query.
func (ifdo *ItemFieldDeleteOne) Exec(ctx context.Context) error {
	n, err := ifdo.ifd.Exec(ctx)
	switch {
	case err != nil:
		return err
	case n == 0:
		return &NotFoundError{itemfield.Label}
	default:
		return nil
	}
}

// ExecX is like Exec, but panics if an error occurs.
func (ifdo *ItemFieldDeleteOne) ExecX(ctx context.Context) {
	if err := ifdo.Exec(ctx); err != nil {
		panic(err)
	}
}
